﻿using Microsoft.AspNetCore.Mvc;
using Model;
using StubLib;
using DTO;
using DTO.Mapper;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace API_LoL.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ChampionsController : ControllerBase
    {

       public ChampionsController(IDataManager Manager) {
            this.ChampionsManager= Manager.ChampionsMgr;
       }

        private IChampionsManager ChampionsManager;

        // GET: api/<ChampionController>
        [HttpGet]
        public async Task<IActionResult> Get()
        {
            var list = await ChampionsManager.GetItems(0,await ChampionsManager.GetNbItems());
            if (list.Count() != 0) {
                return Ok(list.Select(champion => champion?.ToDTO()));
            }else { 
                return NoContent();
            }
        }

        // GET api/<ChampionController>/5
        /*
        [HttpGet("{id}")]
        public string Get(String name)
        {
            return "value";
        }*/

        // POST api/<ChampionController>
        [HttpPost]
        public async Task<IActionResult> Post(ChampionDTO champion)
        {
            if (champion == null)
            {
                return UnprocessableEntity();
            }
            else
            {
                await ChampionsManager.AddItem(champion.ToChampion());
                return CreatedAtAction("Post",champion);
            }
        }

        // PUT api/<ChampionController>/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody] string value)
        {
        }

        // DELETE api/<ChampionController>/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}
